/*---------------------------------NewUser.c-------------------------------*\
   All files in this archive (with the exception of COPYING) are 
   Copyright (c) 1996 Michael Maxwell --Quantum Software Development
   See the file COPYING for further information.
\*-------------------------------------------------------------------------*/

#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>


/* Edit the defines here for your system.  In most cases, these are the
 * correct values.  At most, you may wish to have the mail sent to
 * someone other than root.  NOTE: if you do this, you may have to change
 * some permissions, since, by default, all files for this program are
 * read only by user "new" and setuid.
 */
#define NEWUSERAPP "/tmp/.NewUser/NewApp"
#define WEB_BROWSER "/usr/local/bin/lynx"
#define SEND_INFO "/bin/cat /tmp/.NewUser/NewApp | /bin/mail -s \"New User App\" root"
#define LOG_EMRG "echo \"NewUser: Missing file or dir in /tmp/.NewUser\" | /bin/mail -s \"NewUser Warning\" root"

/* ------------------------------------------------------------------------ */
char *Warning[] = {
  "\r\n",
  "Before we proceed, I need to ask you a few questions about yourself.\r\n",
  "The answers to your questions will be kept strictly confidential.  Your\r\n",
  "answers determine whether or not your get access to this system, and\r\n",
  "since this is not a \"free\" service, I will be required to contact you.\r\n",
  "\r\n",
  0
}, **WarnPtr;


char *What[] = {
"\r\n",
"Thank you for taking the time to fill out the questionairre.  The System\r\n",
"Administrators will review your application and contact you with your \r\n",
"login name and password either by mail or by phone, depending on which\r\n",
"method you selected.\r\n",
0
}, **WhatPtr;

char *Stringstuff[] = {
  "\r\n",                                                /*  0 */
  "What is your First and Last name?\r\n",               /*  1 */
  "Please enter your ",                                  /*  2 */
  "daytime telephone number\r\n",                        /*  3 */
  "evening telephone number\r\n",                        /*  4 */
  "street address (include apt #)\r\n",                  /*  5 */
  "city, state\r\n",                                     /*  6 */
  "zipcode\r\n",                                         /*  7 */
  "  Your Command -> ",                                  /*  8 */
  0
}, **StrPtr;

char *LoginName[] = {
  "Please enter 3 choices for a login name.  This is the name that you will\r\n",
  "need to use to login to the system.  It should be no more than 8 characters\r\n",
  "in length.  (Examples:  jpublic, killor, jennyp, etc...)\r\n",
  /* next is 3 */
  "Please enter the name you wish to be made visible to other users.  This \r\n",
  "name will show on your Usenet postings and Mail headers.  Most folks use\r\n",
  "their real name here, but some prefer not to.  The system operators make\r\n",
  "the final determination if it's appropriate, so don't make it anything\r\n",
  "obscene, ok?\r\n",
  0
}, **LoginNamePtr;

char *Menu[] = {
"\r\n",
"                                 -*- Menu -*-\r\n",
"\r\n",
"                       (A)pply for UNIX Shell Access\r\n",
"                       (H)ome Page --See Our Home Page\r\n",
"                       (O)ff --Logout, Goodbye!\r\n",
"\r\n",
0
}, **MenuPtr;

int GetInput(void);
int ConfirmTrue(void);
int SaveInfo(void);
int PressKey(void);

void SigTrap(int sig)
{
  /* Does nothing.  Interrupt trap. */
}

FILE * NewUser;
char MenuCmd[5];

char UN[75];                 /* User Name */
char UDPh[20];               /* User Daytime Phone */
char UEPh[20];               /* User Evening Phone */
char SA[75];                 /* Street Address */
char CS[75];                 /* City, State */
char Zip[15];                /* Zipcode */
char Name_a[10];             /* First login name choice */
char Name_b[10];             /* Second login name choice */
char Name_c[10];             /* Third login name choice */
char Gecos[75];              /* Choice for gecos field */
char Contact[75];            /* Method of contact */

int main()
{
  struct sigaction act;
  
  act.sa_handler=SigTrap;
  sigemptyset(&act.sa_mask);
  act.sa_flags=0;
  
  sigaction(SIGINT, &act, 0);
  sigaction(SIGQUIT, &act, 0);
  sigaction(SIGTSTP, &act, 0);

  while (1) {
    for (MenuPtr=Menu; *MenuPtr; MenuPtr++) {
      fprintf(stdout, "%s", *MenuPtr);
    }
    fprintf(stdout, "%s", Stringstuff[8]);
    fgets(MenuCmd, sizeof(MenuCmd), stdin);
    switch (MenuCmd[0]) {
    case 'o':
    case 'O':
      fprintf(stdout, "Goodbye.  Thank you for calling.\r\n");
      exit(0);
    case 'a':
    case 'A':
      GetInput();
      ConfirmTrue();
      SaveInfo();
      break;
    case 'h':
    case 'H':
      system(WEB_BROWSER);
      break;
    default:
      fprintf(stdout, "\r\nInvalid input.\r\n\r\n");
      break;
    }
  }
  exit(0);
}


int GetInput(void)
{
  
  for (WarnPtr=Warning; *WarnPtr; WarnPtr++) {
    fprintf(stdout, "%s", *WarnPtr);
  }
  PressKey();
  
  fprintf(stdout, "%s:", Stringstuff[1]);
  fgets(UN, sizeof(UN), stdin);
  fprintf(stdout, "%s%s:", Stringstuff[2], Stringstuff[3]);
  fgets(UDPh, sizeof(UDPh), stdin);
  fprintf(stdout, "%s%s:", Stringstuff[2], Stringstuff[4]);
  fgets(UEPh, sizeof(UEPh), stdin);
  fprintf(stdout, "%s%s:", Stringstuff[2], Stringstuff[5]);
  fgets(SA, sizeof(SA), stdin);
  fprintf(stdout, "%s%s:", Stringstuff[2], Stringstuff[6]);
  fgets(CS, sizeof(CS), stdin);
  fprintf(stdout, "%s%s:", Stringstuff[2], Stringstuff[7]);
  fgets(Zip, sizeof(Zip), stdin);
  fprintf(stdout, "%s", Stringstuff[0]);

  fprintf(stdout, "%s%s%s", LoginName[0], LoginName[1], LoginName[2]);
  fprintf(stdout, "Choice 1 of 3: ");
  fgets(Name_a, sizeof(Name_a), stdin);
  fprintf(stdout, "Choice 2 of 3: ");
  fgets(Name_b, sizeof(Name_b), stdin);
  fprintf(stdout, "Choice 3 of 3: ");
  fgets(Name_c, sizeof(Name_c), stdin);

  fprintf(stdout, "\r\n%s%s%s", LoginName[3], LoginName[4], LoginName[5]);
  fprintf(stdout, "%s%s", LoginName[6], LoginName[7]);
  fprintf(stdout, ":");
  fgets(Gecos, sizeof(Gecos), stdin);
  
  fprintf(stdout, "Do you wish to be contacted by MAIL or by PHONE?\r\n");
  fprintf(stdout, ":");
  fgets(Contact, sizeof(Contact), stdin);
  return(0);
  
}


int ConfirmTrue(void)
{
  fprintf(stdout, "\r\n");
  fprintf(stdout, "The Following Information will be sent to the Sysop:\r\n");
  fprintf(stdout, "\r\n");
  fprintf(stdout, "  A. Name     : %s", UN);
  fprintf(stdout, "  B. DayPhone : %s", UDPh);
  fprintf(stdout, "  C. EvePhone : %s", UEPh);
  fprintf(stdout, "  D. Address  : %s", SA);
  fprintf(stdout, "  E. CityState: %s", CS);
  fprintf(stdout, "  F. Zip      : %s", Zip);
  fprintf(stdout, "==============================\r\n\r\n");
  fprintf(stdout, " -Preferred Login Names:\r\n");
  fprintf(stdout, "  G. Choice 1 : %s", Name_a);
  fprintf(stdout, "  H. Choice 2 : %s", Name_b);
  fprintf(stdout, "  I. Choice 3 : %s", Name_c);
  fprintf(stdout, "==============================\r\n\r\n");
  fprintf(stdout, " -Preferred \"visible\" name: \r\n");
  fprintf(stdout, "  J. AKA      : %s", Gecos);
  fprintf(stdout, "==============================\r\n\r\n");
  fprintf(stdout, " -Prefer to be contacted by:\r\n");
  fprintf(stdout, "  K. Contact  : %s", Contact);
  fprintf(stdout, "\r\n");

  PressKey();
  fprintf(stdout, "Saving information...");
  return(0);
}

int SaveInfo(void)
{
  NewUser=fopen(NEWUSERAPP, "w");
  if (!NewUser) {
    fprintf(stdout, "ERROR: Error saving info. Exiting with -1!\r\n");
    system(LOG_EMRG);
    exit(-1);
  }
  fprintf(NewUser, "\r\n");
  fprintf(NewUser, "  A. Name     : %s", UN);
  fprintf(NewUser, "  B. DayPhone : %s", UDPh);
  fprintf(NewUser, "  C. EvePhone : %s", UEPh);
  fprintf(NewUser, "  D. Address  : %s", SA);
  fprintf(NewUser, "  E. CityState: %s", CS);
  fprintf(NewUser, "  F. Zip      : %s", Zip);
  fprintf(NewUser, "==============================\r\n\r\n");
  fprintf(NewUser, " -Preferred Login Names:\r\n");
  fprintf(NewUser, "  G. Choice 1 : %s", Name_a);
  fprintf(NewUser, "  H. Choice 2 : %s", Name_b);
  fprintf(NewUser, "  I. Choice 3 : %s", Name_c);
  fprintf(NewUser, "==============================\r\n\r\n");
  fprintf(NewUser, " -Preferred \"visible\" name: \r\n");
  fprintf(NewUser, "  J. AKA      : %s", Gecos);
  fprintf(NewUser, "\r\n===============================\r\n\r\n");
  fprintf(NewUser, "Contact by: %s", Contact);
  fprintf(NewUser, "\r\n");
  
  fclose(NewUser);
  system(SEND_INFO);
  sleep(2);
  fprintf(stdout, " Saved!\r\n");
  
  for (WhatPtr=What; *WhatPtr; WhatPtr++) {
    fprintf(stdout, "%s", *WhatPtr);
  }
  PressKey();
  return(0);
}
  
int PressKey(void)
{
  fprintf(stdout, "\r\nPress[Return]");
  getchar();
  return(0);
}
